/*
 * A hacked version of GNUstep's GSAlertPanel to run non-modally
 * Yanked from GNUstep's NSAlert.m.
 *
 * This is a bit awkward to put in the application, but I can't think
 * of a better way to do this.  If I hack GSAlertPanel from the outside,
 * 1. it depends on delicate internals, and 2. it's not portable to Mac.
 */

/*
   Copyright (C) 1998, 2000, 2004 Free Software Foundation, Inc.

   Author: Fred Kiefer <FredKiefer@gmx.de>
   Date: July 2004

   GSAlertPanel and alert panel functions implementation
   Author: Richard Frith-Macdonald <richard@brainstorm.co.uk>
   Date: 1998

   GSAlertPanel and alert panel functions cleanup and improvements (scroll view)
   Author: Pascal J. Bourguignon <pjb@imaginet.fr>>
   Date: 2000-03-08

   This file is part of the GNUstep GUI Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#import <AppKit/NSPanel.h>

@class NSButton, NSTextField, NSScrollView, NSString;

@interface	NonModalAlertPanel : NSPanel
{
  NSButton	*defButton;
  NSButton	*altButton;
  NSButton	*othButton;
  NSButton	*icoButton;
  NSTextField	*titleField;
  NSTextField	*messageField;
  NSScrollView	*scroll;
  int		result;
  id		target;
  SEL		action;
}

- (id) init;
- (void) setTitle: (NSString*)title
	  message: (NSString*)message
	      def: (NSString*)defaultButton
	      alt: (NSString*)alternateButton
	    other: (NSString*)otherButton;
- (void) sizePanelToFit;
- (void) buttonAction: (id)sender;

- (void)setTarget:t;
- (void)setAction:(SEL)a;
- target;
- (SEL)action;
@end

